{ pkgs, lib, python3Packages, python3, gtk3, gobject-introspection, git, wrapGAppsHook, gnome }:

python3Packages.buildPythonApplication rec {
  pname = "key-mapper";
  version = "1.0.0";

  buildInputs = [ gobject-introspection gtk3 gnome.adwaita-icon-theme ];

  nativeBuildInputs = [ wrapGAppsHook ];

  propagatedBuildInputs = with python3.pkgs; [ setuptools pydbus evdev pygobject3 ];

  src = builtins.fetchGit {
    url = "https://github.com/sezanzeb/key-mapper.git";
    ref = version;
  };

  doCheck = false;
  strictDeps = false;

  patches = [
    ./add-scripts.patch
    ./hack-data-dir.patch
  ];

  # Required as we otherwise don't get the dbus policy installed
  # correctly
  preInstall = ''
    # see https://github.com/pypa/setuptools/issues/130
    ${python3}/bin/${python3.executable} setup.py install_data --install-dir=$out --root=$out
  '';
  
  meta = with lib; {
    homepage = "https://github.com/sezanzeb/key-mapper";
    description = "A tool to change the mapping of your input device buttons";
    license = licenses.gpl3;
    maintainers = [ ];
    platforms = lib.platforms.linux;
  };
}
